

// This C++ file was created by SanEditor

#include "Atomic/HW/HWSAN.h"

#include <stdlib.h>
#include <iostream.h>

#include <math.h>


/*****************************************************************
                         HWSAN Constructor             
******************************************************************/


HWSAN::HWSAN(){


  Activity* InitialActionList[2]={
    &ProcessorFail, //0
    &ProcessorRepair  // 1
  };

  BaseGroupClass* InitialGroupList[2]={
    (BaseGroupClass*) &(ProcessorFail), 
    (BaseGroupClass*) &(ProcessorRepair)
  };

  procFailed = new Place("procFailed" ,0);
  systemFailure = new Place("systemFailure" ,0);
  int temp_Processorsprocvalue = 1;
  Processors = new proc("Processors",temp_Processorsprocvalue);
  profFailedAr_state temp_ProcNrFailedprofFailedAr = {0,0};
  ProcNrFailed = new profFailedAr("ProcNrFailed",temp_ProcNrFailedprofFailedAr);
  toService_state temp_ProcFixedtoService = {0,0};
  ProcFixed = new toService("ProcFixed",temp_ProcFixedtoService);
  profFailedAr_state temp_ProcNrFailedServiceprofFailedAr = {0,0};
  ProcNrFailedService = new profFailedAr("ProcNrFailedService",temp_ProcNrFailedServiceprofFailedAr);
  BaseStateVariableClass* InitialPlaces[6]={
    procFailed,  // 0
    systemFailure,  // 1
    Processors,  // 2
    ProcNrFailed,  // 3
    ProcFixed,  // 4
    ProcNrFailedService   // 5
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("HW", 6, InitialPlaces, 
                        0, InitialROPlaces, 
                        2, InitialActionList, 2, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[8][2]={ 
    {0,0}, {1,0}, {2,0}, {3,0}, {5,0}, {0,1}, {2,1}, {4,1}
  };
  for(int n=0;n<8;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[2][2]={ 
    {0,0}, {0,1}
  };
  for(int n=0;n<2;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<2;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void HWSAN::CustomInitialization() {

}
HWSAN::~HWSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void HWSAN::assignPlacesToActivitiesInst(){
}
void HWSAN::assignPlacesToActivitiesTimed(){
  ProcessorFail.procFailed = (Place*) LocalStateVariables[0];
  ProcessorFail.systemFailure = (Place*) LocalStateVariables[1];
  ProcessorFail.Processors = (proc*) LocalStateVariables[2];
  ProcessorFail.ProcNrFailed = (profFailedAr*) LocalStateVariables[3];
  ProcessorFail.ProcNrFailedService = (profFailedAr*) LocalStateVariables[5];
  ProcessorRepair.procFailed = (Place*) LocalStateVariables[0];
  ProcessorRepair.Processors = (proc*) LocalStateVariables[2];
  ProcessorRepair.ProcFixed = (toService*) LocalStateVariables[4];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================ProcessorFailActivity========================*/

HWSAN::ProcessorFailActivity::ProcessorFailActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("ProcessorFail",0,Exponential, RaceEnabled, 5,1, false);
}

HWSAN::ProcessorFailActivity::~ProcessorFailActivity(){
  delete[] TheDistributionParameters;
}

void HWSAN::ProcessorFailActivity::LinkVariables(){
  procFailed->Register(&procFailed_Mobius_Mark);
  systemFailure->Register(&systemFailure_Mobius_Mark);



}

bool HWSAN::ProcessorFailActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((procFailed->Mark()<4));
  return NewEnabled;
}

double HWSAN::ProcessorFailActivity::Rate(){
  return (numProc-(procFailed->Mark())+1)*lambdaProc;
  return 1.0;  // default rate if none is specified
}

double HWSAN::ProcessorFailActivity::Weight(){ 
  return 1;
}

bool HWSAN::ProcessorFailActivity::ReactivationPredicate(){ 
  return false;
}

bool HWSAN::ProcessorFailActivity::ReactivationFunction(){ 
  return false;
}

double HWSAN::ProcessorFailActivity::SampleDistribution(){
  return TheDistribution->Exponential((numProc-(procFailed->Mark())+1)*lambdaProc);
}

double* HWSAN::ProcessorFailActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int HWSAN::ProcessorFailActivity::Rank(){
  return 1;
}

BaseActionClass* HWSAN::ProcessorFailActivity::Fire(){
  ;
  #include <cstdlib>

//Create an array of all operative processors. 
//Pick one random processor that failes.
int a;
int b;
int i;
int n=0;
int o = numProc-procFailed->Mark();
int Up [o];

for(i=0; i<numProc; i++){
	
	if(Processors->Index(i)->Mark()==1){
		Up[n]=i;
		n++;
	}
}

a = (rand() % o);
b = Up[a];
Processors -> Index(b) -> Mark() = 0;
ProcNrFailed ->Index(0)->Mark() = 1;
ProcNrFailed ->Index(1)->Mark() = b;
ProcNrFailedService ->Index(0)->Mark() = 1;
ProcNrFailedService ->Index(1)->Mark() = b;
procFailed->Mark() ++;

if(procFailed->Mark() >= (numProc-1)){
	systemFailure->Mark() =1;
}


	

  return this;
}

/*======================ProcessorRepairActivity========================*/

HWSAN::ProcessorRepairActivity::ProcessorRepairActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("ProcessorRepair",1,Exponential, RaceEnabled, 3,1, false);
}

HWSAN::ProcessorRepairActivity::~ProcessorRepairActivity(){
  delete[] TheDistributionParameters;
}

void HWSAN::ProcessorRepairActivity::LinkVariables(){
  procFailed->Register(&procFailed_Mobius_Mark);


}

bool HWSAN::ProcessorRepairActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((procFailed->Mark()>0));
  return NewEnabled;
}

double HWSAN::ProcessorRepairActivity::Rate(){
  return muMan;
  return 1.0;  // default rate if none is specified
}

double HWSAN::ProcessorRepairActivity::Weight(){ 
  return 1;
}

bool HWSAN::ProcessorRepairActivity::ReactivationPredicate(){ 
  return false;
}

bool HWSAN::ProcessorRepairActivity::ReactivationFunction(){ 
  return false;
}

double HWSAN::ProcessorRepairActivity::SampleDistribution(){
  return TheDistribution->Exponential(muMan);
}

double* HWSAN::ProcessorRepairActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int HWSAN::ProcessorRepairActivity::Rank(){
  return 1;
}

BaseActionClass* HWSAN::ProcessorRepairActivity::Fire(){
  ;
  
#include <cstdlib>
int a;
int b;
int i;
int n=0;
int fail = procFailed->Mark();
int Down [fail];

for(i=0; i<numProc; i++){
	
	if(Processors->Index(i)->Mark()==0){
		Down[n]=i;
		n++;
	}
}

a = (rand() % procFailed->Mark());
b = Down[a];
Processors -> Index(b) -> Mark() =1;
ProcFixed ->Index(0)->Mark() = 1;
ProcFixed ->Index(1)->Mark() = b;
	
procFailed->Mark() --;
  return this;
}

