

// This C++ file was created by SanEditor

#include "Atomic/RM/RMSAN.h"

#include <stdlib.h>
#include <iostream.h>

#include <math.h>


/*****************************************************************
                         RMSAN Constructor             
******************************************************************/


RMSAN::RMSAN(){


  Activity* InitialActionList[6]={
    &reactToProcFailed, //0
    &reactToProcFixed, //1
    &reactioToViewChange, //2
    &Instantaneous_Activity1, //3
    &RMfail, //4
    &RMrepair  // 5
  };

  BaseGroupClass* InitialGroupList[6]={
    (BaseGroupClass*) &(RMfail), 
    (BaseGroupClass*) &(RMrepair), 
    (BaseGroupClass*) &(reactToProcFailed), 
    (BaseGroupClass*) &(reactToProcFixed), 
    (BaseGroupClass*) &(reactioToViewChange), 
    (BaseGroupClass*) &(Instantaneous_Activity1)
  };

  rmUp = new Place("rmUp" ,3);
  procFailed = new Place("procFailed" ,0);
  viewServiceChosen = new Place("viewServiceChosen" ,0);
  ServicesInQueue = new Place("ServicesInQueue" ,0);
  pointer = new Place("pointer" ,0);
  queuePointer = new Place("queuePointer" ,0);
  readQueuePointer = new Place("readQueuePointer" ,0);
  systemFailed = new Place("systemFailed" ,0);
  systemFailure = new Place("systemFailure" ,0);
  int temp_RManagRMvalue = 0;
  RManag = new RM("RManag",temp_RManagRMvalue);
  hvor_state temp_ServiceReplicaDisthvemhvahvorvalue = 0;
  ServiceReplicaDist = new hvemhvahvor("ServiceReplicaDist",temp_ServiceReplicaDisthvemhvahvorvalue);
  card_state temp_ServiceParamservvalue = {0,0,0};
  ServiceParam = new serv("ServiceParam",temp_ServiceParamservvalue);
  int temp_LoadDistprocLoadvalue = 0;
  LoadDist = new procLoad("LoadDist",temp_LoadDistprocLoadvalue);
  int temp_Processorsprocvalue = 1;
  Processors = new proc("Processors",temp_Processorsprocvalue);
  int temp_viewNewviewArrayvalue = 3;
  viewNew = new viewArray("viewNew",temp_viewNewviewArrayvalue);
  toService_state temp_viewChangeNewtoService = {0,0};
  viewChangeNew = new toService("viewChangeNew",temp_viewChangeNewtoService);
  profFailedAr_state temp_ProcNrFailedprofFailedAr = {0,0};
  ProcNrFailed = new profFailedAr("ProcNrFailed",temp_ProcNrFailedprofFailedAr);
  int temp_ServiceReplicaQueueSRQvalue = 10000;
  ServiceReplicaQueue = new SRQ("ServiceReplicaQueue",temp_ServiceReplicaQueueSRQvalue);
  toService_state temp_ProcFixedtoService = {0,0};
  ProcFixed = new toService("ProcFixed",temp_ProcFixedtoService);
  int temp_replicasUpreplUpvalue = 0;
  replicasUp = new replUp("replicasUp",temp_replicasUpreplUpvalue);
  NY_state temp_CreationKOvalue = {-1,0};
  Creation = new KO("Creation",temp_CreationKOvalue);
  BaseStateVariableClass* InitialPlaces[21]={
    rmUp,  // 0
    procFailed,  // 1
    viewServiceChosen,  // 2
    ServicesInQueue,  // 3
    pointer,  // 4
    queuePointer,  // 5
    readQueuePointer,  // 6
    systemFailed,  // 7
    systemFailure,  // 8
    RManag,  // 9
    ServiceReplicaDist,  // 10
    ServiceParam,  // 11
    LoadDist,  // 12
    Processors,  // 13
    viewNew,  // 14
    viewChangeNew,  // 15
    ProcNrFailed,  // 16
    ServiceReplicaQueue,  // 17
    ProcFixed,  // 18
    replicasUp,  // 19
    Creation   // 20
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("RM", 21, InitialPlaces, 
                        0, InitialROPlaces, 
                        6, InitialActionList, 6, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[32][2]={ 
    {16,0}, {9,0}, {12,0}, {1,0}, {5,1}, {6,1}, {3,1}, {18,1}, 
    {17,1}, {20,1}, {4,2}, {3,2}, {5,2}, {15,2}, {20,2}, {13,2}, 
    {10,2}, {12,2}, {19,2}, {11,2}, {17,2}, {8,3}, {7,3}, {0,4}, 
    {8,4}, {9,4}, {12,4}, {1,5}, {0,5}, {13,5}, {9,5}, {12,5}
  };
  for(int n=0;n<32;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[8][2]={ 
    {9,0}, {16,0}, {18,1}, {15,2}, {0,2}, {8,3}, {0,4}, {0,5}
  };
  for(int n=0;n<8;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<6;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void RMSAN::CustomInitialization() {
RManag->Index(0)->Mark() = 1;
RManag->Index(1)->Mark() = 1;
RManag->Index(2)->Mark() = 1;
RManag->Index(3)->Mark() = 0;

if (numServices == 3){
ServiceParam->Index(0)->Index(0)->Mark() = 3;
ServiceParam->Index(0)->Index(1)->Mark() = 3;
ServiceParam->Index(0)->Index(2)->Mark() = 1;

ServiceParam->Index(1)->Index(0)->Mark() = 2;
ServiceParam->Index(1)->Index(1)->Mark() = 2;
ServiceParam->Index(1)->Index(2)->Mark() = 1;

ServiceParam->Index(2)->Index(0)->Mark() = 3;
ServiceParam->Index(2)->Index(1)->Mark() = 3;
ServiceParam->Index(2)->Index(2)->Mark() = 1;

int i;
for(i=0; i<numServices; i++){
	replicasUp->Index(i)->Mark()= ServiceParam->Index(i)->Index(1)->Mark();
}
int j;
for(j=0; j<numServices; j++){
	viewNew->Index(j)->Mark() = ServiceParam->Index(j)->Index(0)->Mark();
}

ServiceReplicaDist->Index(0)->Index(0)->Mark() = 1;
ServiceReplicaDist->Index(0)->Index(1)->Mark() = 1;
ServiceReplicaDist->Index(0)->Index(2)->Mark() = 1;
ServiceReplicaDist->Index(0)->Index(3)->Mark() = 0;

ServiceReplicaDist->Index(1)->Index(0)->Mark() = 0;
ServiceReplicaDist->Index(1)->Index(1)->Mark() = 1;
ServiceReplicaDist->Index(1)->Index(2)->Mark() = 1;
ServiceReplicaDist->Index(1)->Index(3)->Mark() = 0;

ServiceReplicaDist->Index(2)->Index(0)->Mark() = 1;
ServiceReplicaDist->Index(2)->Index(1)->Mark() = 0;
ServiceReplicaDist->Index(2)->Index(2)->Mark() = 1;
ServiceReplicaDist->Index(2)->Index(3)->Mark() = 1;

int k;
for(k=0; k<numProc; k++){
	LoadDist->Index(k)->Mark() = (ServiceReplicaDist->Index(0)->Index(k)->Mark()+ServiceReplicaDist->Index(1)->Index(k)->Mark()+ServiceReplicaDist->Index(2)->Index(k)->Mark()+RManag->Index(k)->Mark());
}
}else if (numServices == 4){
ServiceParam->Index(0)->Index(0)->Mark() = 3;
ServiceParam->Index(0)->Index(1)->Mark() = 3;
ServiceParam->Index(0)->Index(2)->Mark() = 1;

ServiceParam->Index(1)->Index(0)->Mark() = 2;
ServiceParam->Index(1)->Index(1)->Mark() = 2;
ServiceParam->Index(1)->Index(2)->Mark() = 1;

ServiceParam->Index(2)->Index(0)->Mark() = 3;
ServiceParam->Index(2)->Index(1)->Mark() = 3;
ServiceParam->Index(2)->Index(2)->Mark() = 1;

ServiceParam->Index(2)->Index(0)->Mark() = 4;
ServiceParam->Index(2)->Index(1)->Mark() = 4;
ServiceParam->Index(2)->Index(2)->Mark() = 2;

int i;
for(i=0; i<numServices; i++){
	replicasUp->Index(i)->Mark()= ServiceParam->Index(i)->Index(1)->Mark();
}
int j;
for(j=0; j<numServices; j++){
	viewNew->Index(j)->Mark() = ServiceParam->Index(j)->Index(0)->Mark();
}

ServiceReplicaDist->Index(0)->Index(0)->Mark() = 1;
ServiceReplicaDist->Index(0)->Index(1)->Mark() = 1;
ServiceReplicaDist->Index(0)->Index(2)->Mark() = 1;
ServiceReplicaDist->Index(0)->Index(3)->Mark() = 0;

ServiceReplicaDist->Index(1)->Index(0)->Mark() = 0;
ServiceReplicaDist->Index(1)->Index(1)->Mark() = 1;
ServiceReplicaDist->Index(1)->Index(2)->Mark() = 1;
ServiceReplicaDist->Index(1)->Index(3)->Mark() = 0;

ServiceReplicaDist->Index(2)->Index(0)->Mark() = 1;
ServiceReplicaDist->Index(2)->Index(1)->Mark() = 0;
ServiceReplicaDist->Index(2)->Index(2)->Mark() = 1;
ServiceReplicaDist->Index(2)->Index(3)->Mark() = 1;

ServiceReplicaDist->Index(2)->Index(0)->Mark() = 1;
ServiceReplicaDist->Index(2)->Index(1)->Mark() = 1;
ServiceReplicaDist->Index(2)->Index(2)->Mark() = 1;
ServiceReplicaDist->Index(2)->Index(3)->Mark() = 1;

int k;
for(k=0; k<numProc; k++){
	LoadDist->Index(k)->Mark() = (ServiceReplicaDist->Index(0)->Index(k)->Mark()+ServiceReplicaDist->Index(1)->Index(k)->Mark()+ServiceReplicaDist->Index(2)->Index(k)->Mark()+RManag->Index(k)->Mark());
}

}



}
RMSAN::~RMSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void RMSAN::assignPlacesToActivitiesInst(){
  reactToProcFailed.RManag = (RM*) LocalStateVariables[9];
  reactToProcFailed.ProcNrFailed = (profFailedAr*) LocalStateVariables[16];
  reactToProcFailed.LoadDist = (procLoad*) LocalStateVariables[12];
  reactToProcFailed.procFailed = (Place*) LocalStateVariables[1];
  reactToProcFixed.ProcFixed = (toService*) LocalStateVariables[18];
  reactToProcFixed.queuePointer = (Place*) LocalStateVariables[5];
  reactToProcFixed.readQueuePointer = (Place*) LocalStateVariables[6];
  reactToProcFixed.ServicesInQueue = (Place*) LocalStateVariables[3];
  reactToProcFixed.ServiceReplicaQueue = (SRQ*) LocalStateVariables[17];
  reactToProcFixed.Creation = (KO*) LocalStateVariables[20];
  reactioToViewChange.viewChangeNew = (toService*) LocalStateVariables[15];
  reactioToViewChange.rmUp = (Place*) LocalStateVariables[0];
  reactioToViewChange.pointer = (Place*) LocalStateVariables[4];
  reactioToViewChange.ServicesInQueue = (Place*) LocalStateVariables[3];
  reactioToViewChange.queuePointer = (Place*) LocalStateVariables[5];
  reactioToViewChange.Creation = (KO*) LocalStateVariables[20];
  reactioToViewChange.Processors = (proc*) LocalStateVariables[13];
  reactioToViewChange.ServiceReplicaDist = (hvemhvahvor*) LocalStateVariables[10];
  reactioToViewChange.LoadDist = (procLoad*) LocalStateVariables[12];
  reactioToViewChange.replicasUp = (replUp*) LocalStateVariables[19];
  reactioToViewChange.ServiceParam = (serv*) LocalStateVariables[11];
  reactioToViewChange.ServiceReplicaQueue = (SRQ*) LocalStateVariables[17];
  Instantaneous_Activity1.systemFailure = (Place*) LocalStateVariables[8];
  Instantaneous_Activity1.systemFailed = (Place*) LocalStateVariables[7];
}
void RMSAN::assignPlacesToActivitiesTimed(){
  RMfail.rmUp = (Place*) LocalStateVariables[0];
  RMfail.systemFailure = (Place*) LocalStateVariables[8];
  RMfail.RManag = (RM*) LocalStateVariables[9];
  RMfail.LoadDist = (procLoad*) LocalStateVariables[12];
  RMrepair.rmUp = (Place*) LocalStateVariables[0];
  RMrepair.procFailed = (Place*) LocalStateVariables[1];
  RMrepair.Processors = (proc*) LocalStateVariables[13];
  RMrepair.RManag = (RM*) LocalStateVariables[9];
  RMrepair.LoadDist = (procLoad*) LocalStateVariables[12];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================reactToProcFailedActivity========================*/


RMSAN::reactToProcFailedActivity::reactToProcFailedActivity(){
  ActivityInitialize("reactToProcFailed",2,Instantaneous , RaceEnabled, 4,2, false);
}

void RMSAN::reactToProcFailedActivity::LinkVariables(){



  procFailed->Register(&procFailed_Mobius_Mark);
}

bool RMSAN::reactToProcFailedActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((RManag->Index(ProcNrFailed->Index(1)->Mark())->Mark()== 1 && ProcNrFailed->Index(0)->Mark()==1));
  return NewEnabled;
}

double RMSAN::reactToProcFailedActivity::Weight(){ 
  return 1;
}

bool RMSAN::reactToProcFailedActivity::ReactivationPredicate(){ 
  return false;
}

bool RMSAN::reactToProcFailedActivity::ReactivationFunction(){ 
  return false;
}

double RMSAN::reactToProcFailedActivity::SampleDistribution(){
  return 0;
}

double* RMSAN::reactToProcFailedActivity::ReturnDistributionParameters(){
    return NULL;
}

int RMSAN::reactToProcFailedActivity::Rank(){
  return 1;
}

BaseActionClass* RMSAN::reactToProcFailedActivity::Fire(){
  ;
  if(ProcNrFailed->Index(0)->Mark()==1){
	int procFailed = ProcNrFailed->Index(1)->Mark();
	int i;

	RManag->Index(procFailed)->Mark() = 0;
	LoadDist->Index(procFailed)->Mark() = 0;
	ProcNrFailed ->Index(0)->Mark() = 0;
	ProcNrFailed ->Index(1)->Mark() = 0;
}

  return this;
}

/*======================reactToProcFixedActivity========================*/


RMSAN::reactToProcFixedActivity::reactToProcFixedActivity(){
  ActivityInitialize("reactToProcFixed",3,Instantaneous , RaceEnabled, 6,1, false);
}

void RMSAN::reactToProcFixedActivity::LinkVariables(){

  queuePointer->Register(&queuePointer_Mobius_Mark);
  readQueuePointer->Register(&readQueuePointer_Mobius_Mark);
  ServicesInQueue->Register(&ServicesInQueue_Mobius_Mark);


}

bool RMSAN::reactToProcFixedActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((ProcFixed->Index(0)->Mark() == 1));
  return NewEnabled;
}

double RMSAN::reactToProcFixedActivity::Weight(){ 
  return 1;
}

bool RMSAN::reactToProcFixedActivity::ReactivationPredicate(){ 
  return false;
}

bool RMSAN::reactToProcFixedActivity::ReactivationFunction(){ 
  return false;
}

double RMSAN::reactToProcFixedActivity::SampleDistribution(){
  return 0;
}

double* RMSAN::reactToProcFixedActivity::ReturnDistributionParameters(){
    return NULL;
}

int RMSAN::reactToProcFixedActivity::Rank(){
  return 1;
}

BaseActionClass* RMSAN::reactToProcFixedActivity::Fire(){
  ;
  //check queue to see if it contains any services. FCFS.
int i;

int fixed = ProcFixed->Index(1)->Mark();
if(ServiceReplicaQueue->Index(queuePointer->Mark())->Mark()<numServices){
    
	int ServiceCreation = ServiceReplicaQueue->Index(0)->Mark();
    Creation->Index(ServiceCreation)->Index(0)->Mark() = 1;
    Creation->Index(ServiceCreation)->Index(1)->Mark() = fixed;

    for(i=0; i<numServices; i++){
        if(ServiceReplicaQueue->Index(i)->Mark()<numServices){
            ServiceReplicaQueue->Index(i)->Mark() = ServiceReplicaQueue->Index(i+1)->Mark();
            if(ServiceReplicaQueue->Index(i+2)->Mark()>numServices){
                ServiceReplicaQueue->Index(i+1)->Mark() = 11000;
            }
        }
    }
   
	readQueuePointer->Mark() = ((readQueuePointer->Mark()+1)%numServices);
	ServicesInQueue->Mark() --;
}

//Check the load
//If big enough difference,  move some load to new processor. 

//int j;

//for(j=0; j<numProc; j++){
//	if(LoadDist->Index(fixed)->Mark() < numServices){
//		if(LoadDist->Index(j)->Mark() > ((numServices+1)/2)){
			
			//tjenesten som velges m ha flere enn en replica!
//			//endre servicereplicaDist for valgt tjeneste!
//			int possible[numServices];
//			int n=0; 
//			int k=0;
//				for(k=0; k<numServices; k++){
//					if(ServiceReplicaDist->Index(k)->Index(j)->Mark()==1 && replicasUp->Index(k)->Mark()>1){
//						possible[n] = k;
//						n++;
//					}
//				}
//				if(n>0){
//					//Velger en tilfeldig av de mulige tjenestene
//					int choise = possible[(rand() % n)];	
//					LoadDist->Index(j)->Mark() --;
//					ServiceReplicaDist->Index(choise)->Index(j)->Mark() = 0;
//					replicasUp->Index(choise)->Mark() --;
//					Creation->Index(pointer->Mark())->Index(0)->Mark() = fixed;
//					Creation->Index(pointer->Mark())->Index(0)->Mark() = choise;
//					pointer->Mark() = ((pointer->Mark()+1)%numServices);
//				}
//		}
//	}
//}


ProcFixed->Index(0)->Mark() = 0;
ProcFixed->Index(1)->Mark() = 0;
  return this;
}

/*======================reactioToViewChangeActivity========================*/


RMSAN::reactioToViewChangeActivity::reactioToViewChangeActivity(){
  ActivityInitialize("reactioToViewChange",4,Instantaneous , RaceEnabled, 11,2, false);
}

void RMSAN::reactioToViewChangeActivity::LinkVariables(){

  rmUp->Register(&rmUp_Mobius_Mark);
  pointer->Register(&pointer_Mobius_Mark);
  ServicesInQueue->Register(&ServicesInQueue_Mobius_Mark);
  queuePointer->Register(&queuePointer_Mobius_Mark);







}

bool RMSAN::reactioToViewChangeActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((viewChangeNew->Index(0)->Mark()==1 && rmUp ->Mark() > 0));
  return NewEnabled;
}

double RMSAN::reactioToViewChangeActivity::Weight(){ 
  return 1;
}

bool RMSAN::reactioToViewChangeActivity::ReactivationPredicate(){ 
  return false;
}

bool RMSAN::reactioToViewChangeActivity::ReactivationFunction(){ 
  return false;
}

double RMSAN::reactioToViewChangeActivity::SampleDistribution(){
  return 0;
}

double* RMSAN::reactioToViewChangeActivity::ReturnDistributionParameters(){
    return NULL;
}

int RMSAN::reactioToViewChangeActivity::Rank(){
  return 1;
}

BaseActionClass* RMSAN::reactioToViewChangeActivity::Fire(){
  ;
  


int ytre;
int n= 0;

//finner hvilken tjeneste som har endret view
int servChosen = viewChangeNew->Index(1)->Mark();
int procChosen;
int load;

int possible[numProc];



int counter;

	//Add creation to creationQueue if not allready in it.

	int k;
	int inQueue=0;
	for(k=0; k<numServices; k++){
		if(servChosen == Creation->Index(k)->Index(0)->Mark()){
			inQueue = 1;
		}
	}
if(inQueue==0){ 

//lage en array med processorer replica kan opprettes p (prosessor oppe og har ikke replika fra fr) 
for(counter = 0; counter < numProc; counter++){
    if((Processors->Index(counter)->Mark() == 1) && (ServiceReplicaDist->Index(servChosen)->Index(counter)->Mark()==0 && LoadDist->Index(counter)->Mark() < Cap) ){
	if(replicasUp->Index(servChosen)->Mark() < ServiceParam->Index(servChosen)->Index(1)->Mark()){
        	possible[n]= counter;
        	n++;
	}
	}
}

if(n>0){
 

	  	//Find the processor with the lightest load
	int j;
	int temp = 100000;
	for(j=0; j<n; j++){
    		if(LoadDist->Index(possible[j])->Mark()<temp){
        		temp = LoadDist->Index(possible[j])->Mark();   
			procChosen = possible[j];
    		}
	}



	Creation->Index(pointer->Mark())->Index(0)->Mark() = servChosen;
	Creation->Index(pointer->Mark())->Index(1)->Mark() = procChosen;
	pointer->Mark()= ((pointer->Mark()+1)% numServices);	
}else{
	//Add service to queue if it is not allready in it
	int x;
	int test;
	for(x=0; x<ServicesInQueue->Mark(); x++ ){
		if(servChosen == ServiceReplicaQueue->Index(queuePointer->Mark())->Mark()){
			test= 1;
		}
	}
	if(test==0){
		ServiceReplicaQueue->Index(queuePointer->Mark())->Mark() = servChosen;
		ServicesInQueue->Mark()++;
		queuePointer->Mark() = ((queuePointer->Mark()+1)%numServices);
	}
}
}

viewChangeNew->Index(0)->Mark()=0;
viewChangeNew->Index(1)->Mark()=0;
  return this;
}

/*======================Instantaneous_Activity1Activity========================*/


RMSAN::Instantaneous_Activity1Activity::Instantaneous_Activity1Activity(){
  ActivityInitialize("Instantaneous_Activity1",5,Instantaneous , RaceEnabled, 2,1, false);
}

void RMSAN::Instantaneous_Activity1Activity::LinkVariables(){
  systemFailure->Register(&systemFailure_Mobius_Mark);
  systemFailed->Register(&systemFailed_Mobius_Mark);
}

bool RMSAN::Instantaneous_Activity1Activity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((systemFailure->Mark() == 1));
  return NewEnabled;
}

double RMSAN::Instantaneous_Activity1Activity::Weight(){ 
  return 1;
}

bool RMSAN::Instantaneous_Activity1Activity::ReactivationPredicate(){ 
  return false;
}

bool RMSAN::Instantaneous_Activity1Activity::ReactivationFunction(){ 
  return false;
}

double RMSAN::Instantaneous_Activity1Activity::SampleDistribution(){
  return 0;
}

double* RMSAN::Instantaneous_Activity1Activity::ReturnDistributionParameters(){
    return NULL;
}

int RMSAN::Instantaneous_Activity1Activity::Rank(){
  return 1;
}

BaseActionClass* RMSAN::Instantaneous_Activity1Activity::Fire(){
  ;
  systemFailure->Mark() = 0;
systemFailed->Mark() ++;
  return this;
}

/*======================RMfailActivity========================*/

RMSAN::RMfailActivity::RMfailActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("RMfail",0,Exponential, RaceEnabled, 4,1, false);
}

RMSAN::RMfailActivity::~RMfailActivity(){
  delete[] TheDistributionParameters;
}

void RMSAN::RMfailActivity::LinkVariables(){
  rmUp->Register(&rmUp_Mobius_Mark);
  systemFailure->Register(&systemFailure_Mobius_Mark);


}

bool RMSAN::RMfailActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((rmUp->Mark()>0));
  return NewEnabled;
}

double RMSAN::RMfailActivity::Rate(){
  return (rmUp->Mark())*lambdaProc;
  return 1.0;  // default rate if none is specified
}

double RMSAN::RMfailActivity::Weight(){ 
  return 1;
}

bool RMSAN::RMfailActivity::ReactivationPredicate(){ 
  return false;
}

bool RMSAN::RMfailActivity::ReactivationFunction(){ 
  return false;
}

double RMSAN::RMfailActivity::SampleDistribution(){
  return TheDistribution->Exponential((rmUp->Mark())*lambdaProc);
}

double* RMSAN::RMfailActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int RMSAN::RMfailActivity::Rank(){
  return 1;
}

BaseActionClass* RMSAN::RMfailActivity::Fire(){
  ;
  #include <cstdlib>

//Create an array of all operative rmReplicas. 
//Pick one random replica that failes.
int a;
int b;
int i;
int n=0;
int o = rmUp->Mark();
int Up [o];

for(i=0; i<numProc; i++){
	
	if(RManag->Index(i)->Mark()==1){
		Up[n]=i;
		n++;
	}
}
if(n>o){
a = (rand() % o);
b = Up[a];
RManag -> Index(b) -> Mark() = 0;
LoadDist->Index(b)->Mark() --;	
}
rmUp->Mark() --;
if(rmUp->Mark() <= 1){
	systemFailure->Mark() = 1;
}


  return this;
}

/*======================RMrepairActivity========================*/

RMSAN::RMrepairActivity::RMrepairActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("RMrepair",1,Exponential, RaceEnabled, 5,1, false);
}

RMSAN::RMrepairActivity::~RMrepairActivity(){
  delete[] TheDistributionParameters;
}

void RMSAN::RMrepairActivity::LinkVariables(){
  rmUp->Register(&rmUp_Mobius_Mark);
  procFailed->Register(&procFailed_Mobius_Mark);



}

bool RMSAN::RMrepairActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((rmUp->Mark()<initRM));
  return NewEnabled;
}

double RMSAN::RMrepairActivity::Rate(){
  return muAut;
  return 1.0;  // default rate if none is specified
}

double RMSAN::RMrepairActivity::Weight(){ 
  return 1;
}

bool RMSAN::RMrepairActivity::ReactivationPredicate(){ 
  return false;
}

bool RMSAN::RMrepairActivity::ReactivationFunction(){ 
  return false;
}

double RMSAN::RMrepairActivity::SampleDistribution(){
  return TheDistribution->Exponential(muAut);
}

double* RMSAN::RMrepairActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int RMSAN::RMrepairActivity::Rank(){
  return 1;
}

BaseActionClass* RMSAN::RMrepairActivity::Fire(){
  ;
  //Create an array with the size of the number of processors a new replica can be created on
//Add the matches (the processor) to the array (processor up, no replica)
//Take a random processor
//Create replica on that processor
//TODO: et sted holde orden p hvilke RM som er p hvilke processorer!! Slik at de kan feile nr replica feiler!

int i;
int possibleMatch = (numProc-procFailed->Mark()) - (rmUp->Mark());
int Match [possibleMatch];
int counter=0;
for(i=0; i<numProc; i++){
	
	if(Processors->Index(i)->Mark()==1 && RManag->Index(i)->Mark()==0 && LoadDist->Index(i)->Mark()<Cap){
		Match[counter]=i;
		counter++;
	}
}

int random;
random = (rand() % counter);
int rmToBeRepaired = Match[random];
RManag->Index(rmToBeRepaired)->Mark()= 1;
LoadDist->Index(rmToBeRepaired)->Mark() ++;


rmUp->Mark()++;
  return this;
}

