#ifndef RMSAN_H_
#define RMSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern int numProc;
extern double lambdaProc;
extern int initRM;
extern double muMan;
extern double lambdaView;
extern int numServices;
extern double muAut;
extern short Cap;
extern UserDistributions* TheDistribution;

void MemoryError();

#ifndef _proc_header_
#define _proc_header_

typedef int proc_state;
class proc: public ArrayStateVariable<ExtendedPlace<int> > {
  public:
  proc(char* name):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numProc) {
    char varname[10];
    for (int i=0;i<numProc;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname));
    }
  }

  proc(char* name, int & initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numProc) {
    char varname[10];
    for (int i=0;i<numProc;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue));
    }
  }

  proc(char* name, int * initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numProc) {
    char varname[10];
    for (int i=0;i<numProc;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue[i]));
    }
  }
  ~proc() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif
#ifndef _repl_header_
#define _repl_header_

typedef int repl_state[4];
class repl: public ArrayStateVariable<ExtendedPlace<int> > {
  public:
  repl(char* name):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,4) {
    char varname[10];
    for (int i=0;i<4;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname));
    }
  }

  repl(char* name, int & initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,4) {
    char varname[10];
    for (int i=0;i<4;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue));
    }
  }

  repl(char* name, int * initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,4) {
    char varname[10];
    for (int i=0;i<4;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue[i]));
    }
  }
  ~repl() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif
#ifndef _hvor_header_
#define _hvor_header_

typedef int hvor_state;
class hvor: public ArrayStateVariable<ExtendedPlace<int> > {
  public:
  hvor(char* name):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numProc) {
    char varname[10];
    for (int i=0;i<numProc;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname));
    }
  }

  hvor(char* name, int & initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numProc) {
    char varname[10];
    for (int i=0;i<numProc;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue));
    }
  }

  hvor(char* name, int * initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numProc) {
    char varname[10];
    for (int i=0;i<numProc;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue[i]));
    }
  }
  ~hvor() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif
#ifndef _hvemhvahvor_header_
#define _hvemhvahvor_header_

typedef hvor_state hvemhvahvor_state;
class hvemhvahvor: public ArrayStateVariable<hvor > {
  public:
  hvemhvahvor(char* name):
    ArrayStateVariable<hvor >(name,Array ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new hvor(varname));
    }
  }

  hvemhvahvor(char* name, hvor_state & initialValue):
    ArrayStateVariable<hvor >(name,Array ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new hvor(varname, initialValue));
    }
  }

  hvemhvahvor(char* name, hvor_state * initialValue):
    ArrayStateVariable<hvor >(name,Array ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new hvor(varname, initialValue[i]));
    }
  }
  ~hvemhvahvor() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif
#ifndef _replUp_header_
#define _replUp_header_

typedef int replUp_state;
class replUp: public ArrayStateVariable<ExtendedPlace<int> > {
  public:
  replUp(char* name):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname));
    }
  }

  replUp(char* name, int & initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue));
    }
  }

  replUp(char* name, int * initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue[i]));
    }
  }
  ~replUp() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif
#ifndef _viewArray_header_
#define _viewArray_header_

typedef int viewArray_state;
class viewArray: public ArrayStateVariable<ExtendedPlace<int> > {
  public:
  viewArray(char* name):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname));
    }
  }

  viewArray(char* name, int & initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue));
    }
  }

  viewArray(char* name, int * initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue[i]));
    }
  }
  ~viewArray() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif
#ifndef _RM_header_
#define _RM_header_

typedef int RM_state;
class RM: public ArrayStateVariable<ExtendedPlace<int> > {
  public:
  RM(char* name):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numProc) {
    char varname[10];
    for (int i=0;i<numProc;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname));
    }
  }

  RM(char* name, int & initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numProc) {
    char varname[10];
    for (int i=0;i<numProc;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue));
    }
  }

  RM(char* name, int * initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numProc) {
    char varname[10];
    for (int i=0;i<numProc;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue[i]));
    }
  }
  ~RM() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif
#ifndef _card_header_
#define _card_header_

typedef int card_state[3];
class card: public ArrayStateVariable<ExtendedPlace<int> > {
  public:
  card(char* name):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,3) {
    char varname[10];
    for (int i=0;i<3;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname));
    }
  }

  card(char* name, int & initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,3) {
    char varname[10];
    for (int i=0;i<3;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue));
    }
  }

  card(char* name, int * initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,3) {
    char varname[10];
    for (int i=0;i<3;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue[i]));
    }
  }
  ~card() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif
#ifndef _serv_header_
#define _serv_header_

typedef card_state serv_state;
class serv: public ArrayStateVariable<card > {
  public:
  serv(char* name):
    ArrayStateVariable<card >(name,Array ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new card(varname));
    }
  }

  serv(char* name, card_state & initialValue):
    ArrayStateVariable<card >(name,Array ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new card(varname, initialValue));
    }
  }

  serv(char* name, card_state * initialValue):
    ArrayStateVariable<card >(name,Array ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new card(varname, initialValue[i]));
    }
  }
  ~serv() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif
#ifndef _procLoad_header_
#define _procLoad_header_

typedef int procLoad_state;
class procLoad: public ArrayStateVariable<ExtendedPlace<int> > {
  public:
  procLoad(char* name):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numProc) {
    char varname[10];
    for (int i=0;i<numProc;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname));
    }
  }

  procLoad(char* name, int & initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numProc) {
    char varname[10];
    for (int i=0;i<numProc;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue));
    }
  }

  procLoad(char* name, int * initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numProc) {
    char varname[10];
    for (int i=0;i<numProc;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue[i]));
    }
  }
  ~procLoad() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif
#ifndef _toService_header_
#define _toService_header_

typedef short toService_state[2];
class toService: public ArrayStateVariable<ExtendedPlace<short> > {
  public:
  toService(char* name):
    ArrayStateVariable<ExtendedPlace<short> >(name,Short ,2) {
    char varname[10];
    for (int i=0;i<2;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<short>(varname));
    }
  }

  toService(char* name, short & initialValue):
    ArrayStateVariable<ExtendedPlace<short> >(name,Short ,2) {
    char varname[10];
    for (int i=0;i<2;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<short>(varname, initialValue));
    }
  }

  toService(char* name, short * initialValue):
    ArrayStateVariable<ExtendedPlace<short> >(name,Short ,2) {
    char varname[10];
    for (int i=0;i<2;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<short>(varname, initialValue[i]));
    }
  }
  ~toService() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif
#ifndef _createreplica_header_
#define _createreplica_header_

typedef toService_state createreplica_state[3];
class createreplica: public ArrayStateVariable<toService > {
  public:
  createreplica(char* name):
    ArrayStateVariable<toService >(name,Array ,3) {
    char varname[10];
    for (int i=0;i<3;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new toService(varname));
    }
  }

  createreplica(char* name, toService_state & initialValue):
    ArrayStateVariable<toService >(name,Array ,3) {
    char varname[10];
    for (int i=0;i<3;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new toService(varname, initialValue));
    }
  }

  createreplica(char* name, toService_state * initialValue):
    ArrayStateVariable<toService >(name,Array ,3) {
    char varname[10];
    for (int i=0;i<3;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new toService(varname, initialValue[i]));
    }
  }
  ~createreplica() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif
#ifndef _profFailedAr_header_
#define _profFailedAr_header_

typedef int profFailedAr_state[2];
class profFailedAr: public ArrayStateVariable<ExtendedPlace<int> > {
  public:
  profFailedAr(char* name):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,2) {
    char varname[10];
    for (int i=0;i<2;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname));
    }
  }

  profFailedAr(char* name, int & initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,2) {
    char varname[10];
    for (int i=0;i<2;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue));
    }
  }

  profFailedAr(char* name, int * initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,2) {
    char varname[10];
    for (int i=0;i<2;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue[i]));
    }
  }
  ~profFailedAr() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif
#ifndef _SRQ_header_
#define _SRQ_header_

typedef int SRQ_state;
class SRQ: public ArrayStateVariable<ExtendedPlace<int> > {
  public:
  SRQ(char* name):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname));
    }
  }

  SRQ(char* name, int & initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue));
    }
  }

  SRQ(char* name, int * initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue[i]));
    }
  }
  ~SRQ() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif
#ifndef _NY_header_
#define _NY_header_

typedef int NY_state[2];
class NY: public ArrayStateVariable<ExtendedPlace<int> > {
  public:
  NY(char* name):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,2) {
    char varname[10];
    for (int i=0;i<2;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname));
    }
  }

  NY(char* name, int & initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,2) {
    char varname[10];
    for (int i=0;i<2;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue));
    }
  }

  NY(char* name, int * initialValue):
    ArrayStateVariable<ExtendedPlace<int> >(name,Int ,2) {
    char varname[10];
    for (int i=0;i<2;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new ExtendedPlace<int>(varname, initialValue[i]));
    }
  }
  ~NY() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif
#ifndef _KO_header_
#define _KO_header_

typedef NY_state KO_state;
class KO: public ArrayStateVariable<NY > {
  public:
  KO(char* name):
    ArrayStateVariable<NY >(name,Array ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new NY(varname));
    }
  }

  KO(char* name, NY_state & initialValue):
    ArrayStateVariable<NY >(name,Array ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new NY(varname, initialValue));
    }
  }

  KO(char* name, NY_state * initialValue):
    ArrayStateVariable<NY >(name,Array ,numServices) {
    char varname[10];
    for (int i=0;i<numServices;i++) {
      sprintf(varname,"%d",i);
      fields.push_back(new NY(varname, initialValue[i]));
    }
  }
  ~KO() {
    for (fieldIterator i=fields.begin();i!=fields.end();++i)
      delete (*i);
  }
};
#endif

/*********************************************************************
               RMSAN Submodel Definition                   
*********************************************************************/

class RMSAN:public SANModel{
public:

class reactToProcFailedActivity:public Activity {
public:

  RM* RManag;
  profFailedAr* ProcNrFailed;
  procLoad* LoadDist;
  Place* procFailed;
  short* procFailed_Mobius_Mark;

  double* TheDistributionParameters;
  reactToProcFailedActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // reactToProcFailedActivityActivity

class reactToProcFixedActivity:public Activity {
public:

  toService* ProcFixed;
  Place* queuePointer;
  short* queuePointer_Mobius_Mark;
  Place* readQueuePointer;
  short* readQueuePointer_Mobius_Mark;
  Place* ServicesInQueue;
  short* ServicesInQueue_Mobius_Mark;
  SRQ* ServiceReplicaQueue;
  KO* Creation;

  double* TheDistributionParameters;
  reactToProcFixedActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // reactToProcFixedActivityActivity

class reactioToViewChangeActivity:public Activity {
public:

  toService* viewChangeNew;
  Place* rmUp;
  short* rmUp_Mobius_Mark;
  Place* pointer;
  short* pointer_Mobius_Mark;
  Place* ServicesInQueue;
  short* ServicesInQueue_Mobius_Mark;
  Place* queuePointer;
  short* queuePointer_Mobius_Mark;
  KO* Creation;
  proc* Processors;
  hvemhvahvor* ServiceReplicaDist;
  procLoad* LoadDist;
  replUp* replicasUp;
  serv* ServiceParam;
  SRQ* ServiceReplicaQueue;

  double* TheDistributionParameters;
  reactioToViewChangeActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // reactioToViewChangeActivityActivity

class Instantaneous_Activity1Activity:public Activity {
public:

  Place* systemFailure;
  short* systemFailure_Mobius_Mark;
  Place* systemFailed;
  short* systemFailed_Mobius_Mark;

  double* TheDistributionParameters;
  Instantaneous_Activity1Activity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // Instantaneous_Activity1ActivityActivity

class RMfailActivity:public Activity {
public:

  Place* rmUp;
  short* rmUp_Mobius_Mark;
  Place* systemFailure;
  short* systemFailure_Mobius_Mark;
  RM* RManag;
  procLoad* LoadDist;

  double* TheDistributionParameters;
  RMfailActivity();
  ~RMfailActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // RMfailActivityActivity

class RMrepairActivity:public Activity {
public:

  Place* rmUp;
  short* rmUp_Mobius_Mark;
  Place* procFailed;
  short* procFailed_Mobius_Mark;
  proc* Processors;
  RM* RManag;
  procLoad* LoadDist;

  double* TheDistributionParameters;
  RMrepairActivity();
  ~RMrepairActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // RMrepairActivityActivity

  //List of user-specified place names
  Place* rmUp;
  Place* procFailed;
  Place* viewServiceChosen;
  Place* ServicesInQueue;
  Place* pointer;
  Place* queuePointer;
  Place* readQueuePointer;
  Place* systemFailed;
  Place* systemFailure;
  RM* RManag;
  hvemhvahvor* ServiceReplicaDist;
  serv* ServiceParam;
  procLoad* LoadDist;
  proc* Processors;
  viewArray* viewNew;
  toService* viewChangeNew;
  profFailedAr* ProcNrFailed;
  SRQ* ServiceReplicaQueue;
  toService* ProcFixed;
  replUp* replicasUp;
  KO* Creation;

  // Create instances of all actvities
  reactToProcFailedActivity reactToProcFailed;
  reactToProcFixedActivity reactToProcFixed;
  reactioToViewChangeActivity reactioToViewChange;
  Instantaneous_Activity1Activity Instantaneous_Activity1;
  RMfailActivity RMfail;
  RMrepairActivity RMrepair;
  //Create instances of all groups 
  PreselectGroup ImmediateGroup;
  PostselectGroup reactToProcFailedGroup;
  PostselectGroup reactToProcFixedGroup;
  PostselectGroup reactioToViewChangeGroup;
  PostselectGroup Instantaneous_Activity1Group;

  RMSAN();
  ~RMSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end RMSAN

#endif // RMSAN_H_
