

// This C++ file was created by SanEditor

#include "Atomic/ServiceTestUtenProc/ServiceTestUtenProcSAN.h"

#include <stdlib.h>
#include <iostream.h>

#include <math.h>


/*****************************************************************
                         ServiceTestUtenProcSAN Constructor             
******************************************************************/


ServiceTestUtenProcSAN::ServiceTestUtenProcSAN(){


  Activity* InitialActionList[2]={
    &ProcessorFail, //0
    &ProcessorRepair  // 1
  };

  BaseGroupClass* InitialGroupList[2]={
    (BaseGroupClass*) &(ProcessorFail), 
    (BaseGroupClass*) &(ProcessorRepair)
  };

  procFailed = new Place("procFailed" ,0);
  int temp_Processorsprocvalue = 1;
  Processors = new proc("Processors",temp_Processorsprocvalue);
  BaseStateVariableClass* InitialPlaces[2]={
    procFailed,  // 0
    Processors   // 1
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("ServiceTestUtenProc", 2, InitialPlaces, 
                        0, InitialROPlaces, 
                        2, InitialActionList, 2, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[2][2]={ 
    {0,0}, {0,1}
  };
  for(int n=0;n<2;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[2][2]={ 
    {0,0}, {0,1}
  };
  for(int n=0;n<2;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<2;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void ServiceTestUtenProcSAN::CustomInitialization() {

}
ServiceTestUtenProcSAN::~ServiceTestUtenProcSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void ServiceTestUtenProcSAN::assignPlacesToActivitiesInst(){
}
void ServiceTestUtenProcSAN::assignPlacesToActivitiesTimed(){
  ProcessorFail.procFailed = (Place*) LocalStateVariables[0];
  ProcessorFail.Processors = (proc*) LocalStateVariables[1];
  ProcessorRepair.procFailed = (Place*) LocalStateVariables[0];
  ProcessorRepair.Processors = (proc*) LocalStateVariables[1];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================ProcessorFailActivity========================*/

ServiceTestUtenProcSAN::ProcessorFailActivity::ProcessorFailActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("ProcessorFail",0,Exponential, RaceEnabled, 1,1, false);
}

ServiceTestUtenProcSAN::ProcessorFailActivity::~ProcessorFailActivity(){
  delete[] TheDistributionParameters;
}

void ServiceTestUtenProcSAN::ProcessorFailActivity::LinkVariables(){
  procFailed->Register(&procFailed_Mobius_Mark);

}

bool ServiceTestUtenProcSAN::ProcessorFailActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((procFailed->Mark()<4));
  return NewEnabled;
}

double ServiceTestUtenProcSAN::ProcessorFailActivity::Rate(){
  return (numProc-numFailed)*lambdaProc;
  return 1.0;  // default rate if none is specified
}

double ServiceTestUtenProcSAN::ProcessorFailActivity::Weight(){ 
  return 1;
}

bool ServiceTestUtenProcSAN::ProcessorFailActivity::ReactivationPredicate(){ 
  return false;
}

bool ServiceTestUtenProcSAN::ProcessorFailActivity::ReactivationFunction(){ 
  return false;
}

double ServiceTestUtenProcSAN::ProcessorFailActivity::SampleDistribution(){
  return TheDistribution->Exponential((numProc-numFailed)*lambdaProc);
}

double* ServiceTestUtenProcSAN::ProcessorFailActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int ServiceTestUtenProcSAN::ProcessorFailActivity::Rank(){
  return 1;
}

BaseActionClass* ServiceTestUtenProcSAN::ProcessorFailActivity::Fire(){
  ;
  
procFailed->Mark() ++;
	

  return this;
}

/*======================ProcessorRepairActivity========================*/

ServiceTestUtenProcSAN::ProcessorRepairActivity::ProcessorRepairActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("ProcessorRepair",1,Exponential, RaceEnabled, 1,1, false);
}

ServiceTestUtenProcSAN::ProcessorRepairActivity::~ProcessorRepairActivity(){
  delete[] TheDistributionParameters;
}

void ServiceTestUtenProcSAN::ProcessorRepairActivity::LinkVariables(){
  procFailed->Register(&procFailed_Mobius_Mark);

}

bool ServiceTestUtenProcSAN::ProcessorRepairActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((procFailed->Mark()>0));
  return NewEnabled;
}

double ServiceTestUtenProcSAN::ProcessorRepairActivity::Rate(){
  return muMan;
  return 1.0;  // default rate if none is specified
}

double ServiceTestUtenProcSAN::ProcessorRepairActivity::Weight(){ 
  return 1;
}

bool ServiceTestUtenProcSAN::ProcessorRepairActivity::ReactivationPredicate(){ 
  return false;
}

bool ServiceTestUtenProcSAN::ProcessorRepairActivity::ReactivationFunction(){ 
  return false;
}

double ServiceTestUtenProcSAN::ProcessorRepairActivity::SampleDistribution(){
  return TheDistribution->Exponential(muMan);
}

double* ServiceTestUtenProcSAN::ProcessorRepairActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int ServiceTestUtenProcSAN::ProcessorRepairActivity::Rank(){
  return 1;
}

BaseActionClass* ServiceTestUtenProcSAN::ProcessorRepairActivity::Fire(){
  ;
  

	
procFailed->Mark() --;
  return this;
}

