#include "Composed/compNew/compNewRJ.h"
char * compNewRJ__SharedNames[] = {"Creation", "LoadDist", "ProcFixed", "ProcNrFailed", "ProcNrFailedService", "Processors", "ServiceReplicaDist", "procFailed", "replicasUp", "systemFailure", "viewChangeNew", "viewNew", "viewServiceChosen"};

compNewRJ::compNewRJ():Join("System", 3, 13,compNewRJ__SharedNames) {
  HW = new HWSAN();
  ModelArray[0] = (BaseModelClass*) HW;
  ModelArray[0]->DefineName("HW");
  Service = new ServiceSAN();
  ModelArray[1] = (BaseModelClass*) Service;
  ModelArray[1]->DefineName("Service");
  RM = new RMSAN();
  ModelArray[2] = (BaseModelClass*) RM;
  ModelArray[2]->DefineName("RM");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    Creation = new KO("Creation");
    addSharedPtr(Creation, "Creation" );
    if (Service->NumStateVariables > 0) {
      Creation->ShareWith(Service->Creation);
      addSharingInfo(Service->Creation, Creation);
    }
    if (RM->NumStateVariables > 0) {
      Creation->ShareWith(RM->Creation);
      addSharingInfo(RM->Creation, Creation);
    }

    //Shared variable 1
    LoadDist = new procLoad("LoadDist");
    addSharedPtr(LoadDist, "LoadDist" );
    if (Service->NumStateVariables > 0) {
      LoadDist->ShareWith(Service->LoadDist);
      addSharingInfo(Service->LoadDist, LoadDist);
    }
    if (RM->NumStateVariables > 0) {
      LoadDist->ShareWith(RM->LoadDist);
      addSharingInfo(RM->LoadDist, LoadDist);
    }

    //Shared variable 2
    ProcFixed = new toService("ProcFixed");
    addSharedPtr(ProcFixed, "ProcFixed" );
    if (HW->NumStateVariables > 0) {
      ProcFixed->ShareWith(HW->ProcFixed);
      addSharingInfo(HW->ProcFixed, ProcFixed);
    }
    if (RM->NumStateVariables > 0) {
      ProcFixed->ShareWith(RM->ProcFixed);
      addSharingInfo(RM->ProcFixed, ProcFixed);
    }

    //Shared variable 3
    ProcNrFailed = new profFailedAr("ProcNrFailed");
    addSharedPtr(ProcNrFailed, "ProcNrFailed" );
    if (HW->NumStateVariables > 0) {
      ProcNrFailed->ShareWith(HW->ProcNrFailed);
      addSharingInfo(HW->ProcNrFailed, ProcNrFailed);
    }
    if (RM->NumStateVariables > 0) {
      ProcNrFailed->ShareWith(RM->ProcNrFailed);
      addSharingInfo(RM->ProcNrFailed, ProcNrFailed);
    }

    //Shared variable 4
    ProcNrFailedService = new profFailedAr("ProcNrFailedService");
    addSharedPtr(ProcNrFailedService, "ProcNrFailedService" );
    if (HW->NumStateVariables > 0) {
      ProcNrFailedService->ShareWith(HW->ProcNrFailedService);
      addSharingInfo(HW->ProcNrFailedService, ProcNrFailedService);
    }
    if (Service->NumStateVariables > 0) {
      ProcNrFailedService->ShareWith(Service->ProcNrFailedService);
      addSharingInfo(Service->ProcNrFailedService, ProcNrFailedService);
    }

    //Shared variable 5
    Processors = new proc("Processors");
    addSharedPtr(Processors, "Processors" );
    if (HW->NumStateVariables > 0) {
      Processors->ShareWith(HW->Processors);
      addSharingInfo(HW->Processors, Processors);
    }
    if (Service->NumStateVariables > 0) {
      Processors->ShareWith(Service->Processors);
      addSharingInfo(Service->Processors, Processors);
    }
    if (RM->NumStateVariables > 0) {
      Processors->ShareWith(RM->Processors);
      addSharingInfo(RM->Processors, Processors);
    }

    //Shared variable 6
    ServiceReplicaDist = new hvemhvahvor("ServiceReplicaDist");
    addSharedPtr(ServiceReplicaDist, "ServiceReplicaDist" );
    if (Service->NumStateVariables > 0) {
      ServiceReplicaDist->ShareWith(Service->ServiceReplicaDist);
      addSharingInfo(Service->ServiceReplicaDist, ServiceReplicaDist);
    }
    if (RM->NumStateVariables > 0) {
      ServiceReplicaDist->ShareWith(RM->ServiceReplicaDist);
      addSharingInfo(RM->ServiceReplicaDist, ServiceReplicaDist);
    }

    //Shared variable 7
    procFailed = new Place("procFailed");
    addSharedPtr(procFailed, "procFailed" );
    if (HW->NumStateVariables > 0) {
      procFailed->ShareWith(HW->procFailed);
      addSharingInfo(HW->procFailed, procFailed);
    }
    if (Service->NumStateVariables > 0) {
      procFailed->ShareWith(Service->procFailed);
      addSharingInfo(Service->procFailed, procFailed);
    }
    if (RM->NumStateVariables > 0) {
      procFailed->ShareWith(RM->procFailed);
      addSharingInfo(RM->procFailed, procFailed);
    }

    //Shared variable 8
    replicasUp = new replUp("replicasUp");
    addSharedPtr(replicasUp, "replicasUp" );
    if (Service->NumStateVariables > 0) {
      replicasUp->ShareWith(Service->replicasUp);
      addSharingInfo(Service->replicasUp, replicasUp);
    }
    if (RM->NumStateVariables > 0) {
      replicasUp->ShareWith(RM->replicasUp);
      addSharingInfo(RM->replicasUp, replicasUp);
    }

    //Shared variable 9
    systemFailure = new Place("systemFailure");
    addSharedPtr(systemFailure, "systemFailure" );
    if (HW->NumStateVariables > 0) {
      systemFailure->ShareWith(HW->systemFailure);
      addSharingInfo(HW->systemFailure, systemFailure);
    }
    if (Service->NumStateVariables > 0) {
      systemFailure->ShareWith(Service->systemFailure);
      addSharingInfo(Service->systemFailure, systemFailure);
    }
    if (RM->NumStateVariables > 0) {
      systemFailure->ShareWith(RM->systemFailure);
      addSharingInfo(RM->systemFailure, systemFailure);
    }

    //Shared variable 10
    viewChangeNew = new toService("viewChangeNew");
    addSharedPtr(viewChangeNew, "viewChangeNew" );
    if (Service->NumStateVariables > 0) {
      viewChangeNew->ShareWith(Service->viewChangeNew);
      addSharingInfo(Service->viewChangeNew, viewChangeNew);
    }
    if (RM->NumStateVariables > 0) {
      viewChangeNew->ShareWith(RM->viewChangeNew);
      addSharingInfo(RM->viewChangeNew, viewChangeNew);
    }

    //Shared variable 11
    viewNew = new viewArray("viewNew");
    addSharedPtr(viewNew, "viewNew" );
    if (Service->NumStateVariables > 0) {
      viewNew->ShareWith(Service->viewNew);
      addSharingInfo(Service->viewNew, viewNew);
    }
    if (RM->NumStateVariables > 0) {
      viewNew->ShareWith(RM->viewNew);
      addSharingInfo(RM->viewNew, viewNew);
    }

    //Shared variable 12
    viewServiceChosen = new Place("viewServiceChosen");
    addSharedPtr(viewServiceChosen, "viewServiceChosen" );
    if (Service->NumStateVariables > 0) {
      viewServiceChosen->ShareWith(Service->viewServiceChosen);
      addSharingInfo(Service->viewServiceChosen, viewServiceChosen);
    }
    if (RM->NumStateVariables > 0) {
      viewServiceChosen->ShareWith(RM->viewServiceChosen);
      addSharingInfo(RM->viewServiceChosen, viewServiceChosen);
    }

  }

  Setup();
}

compNewRJ::~compNewRJ() {
  if (!AllChildrenEmpty()) {
    delete Creation;
    delete LoadDist;
    delete ProcFixed;
    delete ProcNrFailed;
    delete ProcNrFailedService;
    delete Processors;
    delete ServiceReplicaDist;
    delete procFailed;
    delete replicasUp;
    delete systemFailure;
    delete viewChangeNew;
    delete viewNew;
    delete viewServiceChosen;
  }
  delete HW;
  delete Service;
  delete RM;
}
