#include "RMavailPVNodes.h"

RMavailPV0Worker::RMavailPV0Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&RM);
}

RMavailPV0Worker::~RMavailPV0Worker() {
  delete [] TheModelPtr;
}

double RMavailPV0Worker::Reward_Function(void) {

if(RM->rmUp->Mark() > 0){
	return 1;
}

return (0);



}

RMavailPV0::RMavailPV0(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&ThecompNewRJ);
  double startpts[1]={500.0};
  double stoppts[1]={500.0+100.0};
  Initialize("RMavailability",(RewardType)3,1, startpts, stoppts, timeindex, 0,1, 1);
  Type = steady_state;
  AddVariableDependency("rmUp","RM");
}

RMavailPV0::~RMavailPV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void RMavailPV0::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new RMavailPV0Worker;
}
