#include "SystemAvailPVNodes.h"

SystemAvailPV0Worker::SystemAvailPV0Worker()
{
  NumModels = 3;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&Service);
  TheModelPtr[1] = (BaseModelClass**)(&RM);
  TheModelPtr[2] = (BaseModelClass**)(&HW);
}

SystemAvailPV0Worker::~SystemAvailPV0Worker() {
  delete [] TheModelPtr;
}

double SystemAvailPV0Worker::Reward_Function(void) {

if(RM->rmUp->Mark()>1 && RM->procFailed->Mark()<(numProc-1) && Service->replicasUp->Index(0)->Mark()>=RM->ServiceParam->Index(0)->Index(2)->Mark()){
	return 1;
}

return (0);



}

SystemAvailPV0::SystemAvailPV0(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&ThecompNewRJ);
  double startpts[1]={500.0};
  double stoppts[1]={500.0+10000.0};
  Initialize("systemAvail",(RewardType)3,1, startpts, stoppts, timeindex, 0,5, 4);
  Type = steady_state;
  AddVariableDependency("replicasUp","Service");
  AddVariableDependency("rmUp","RM");
  AddVariableDependency("procFailed","RM");
  AddVariableDependency("ServiceParam","RM");
  AddModelDependency("HW");
}

SystemAvailPV0::~SystemAvailPV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void SystemAvailPV0::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new SystemAvailPV0Worker;
}
SystemAvailPV1Impulse0::SystemAvailPV1Impulse0()
{
  NumberOfModelDependencies = 1;
  TheModelPtr = new BaseModelClass**[NumberOfModelDependencies];
  TheModelPtr[0] = (BaseModelClass**)(&RM);
  ImpulseWorkerListLength = 0;
}

SystemAvailPV1Impulse0::~SystemAvailPV1Impulse0() {
  delete [] TheModelPtr;
  if (ImpulseWorkerListLength > 0) {
    for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < ImpulseWorkerListLength; ImpulseWorkerCounter++)
      delete ImpulseWorkerList[ImpulseWorkerCounter];
    delete[] ImpulseWorkerList;
  }
}

double SystemAvailPV1Impulse0::Impulse_Function(double FiringTime)
{
return 1;

return(0);
}

ImpulseNodeClass** SystemAvailPV1Impulse0::CreateImpulseWorkerList(int NumberOfWorkers) {
  ImpulseWorkerListLength = NumberOfWorkers;
  ImpulseWorkerList = new ImpulseNodeClass*[NumberOfWorkers];

  for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < NumberOfWorkers; ImpulseWorkerCounter++)
  {
    ImpulseWorkerList[ImpulseWorkerCounter] = new SystemAvailPV1Impulse0;
  }

  return ImpulseWorkerList;
}

SystemAvailPV1::SystemAvailPV1(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&ThecompNewRJ);
  double startpts[1]={500.0};
  double stoppts[1]={500.0+1000.0};
  Initialize("MTBF",(RewardType)3,1, startpts, stoppts, timeindex, 1,0, 0);
  Type = steady_state;
  AddImpulse("Instantaneous_Activity1","RM",&Impulse0);
}

SystemAvailPV1::~SystemAvailPV1() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void SystemAvailPV1::CreateWorkerList(void) {
}
