#ifndef _SYSTEMAVAIL_PVS_
#define _SYSTEMAVAIL_PVS_
#include <math.h>
#include "Cpp/Performance_Variables/PerformanceVariableNode.hpp"
#include "Composed/compNew/compNewRJ.h"
#include "Cpp/Performance_Variables/SteadyState.hpp"
#include "Cpp/Performance_Variables/SteadyStateImpulse.hpp"


class SystemAvailPV0Worker:public SteadyState
{
 public:
  ServiceSAN *Service;
  RMSAN *RM;
  HWSAN *HW;
  
  SystemAvailPV0Worker();
  ~SystemAvailPV0Worker();
  double Reward_Function();
};

class SystemAvailPV0:public PerformanceVariableNode
{
 public:
  compNewRJ *ThecompNewRJ;

  SystemAvailPV0Worker *SystemAvailPV0WorkerList;

  SystemAvailPV0(int timeindex=0);
  ~SystemAvailPV0();
  void CreateWorkerList(void);
};


class SystemAvailPV1Impulse0:public SteadyStateImpulse
{
 public:
  RMSAN *RM;

  SystemAvailPV1Impulse0();
  ~SystemAvailPV1Impulse0();
  double Impulse_Function(double);
  ImpulseNodeClass** CreateImpulseWorkerList(int);
 private:
  ImpulseNodeClass** ImpulseWorkerList;
  int ImpulseWorkerListLength;
};

class SystemAvailPV1:public PerformanceVariableNode
{
 public:
  compNewRJ *ThecompNewRJ;

  SystemAvailPV1Impulse0 Impulse0;

  SystemAvailPV1(int timeindex=0);
  ~SystemAvailPV1();
  void CreateWorkerList(void);
};

#endif
