
#include "Study/FinalExp1/FinalExp1RangeStudy.h"

//******************************************************
//Global Variables
//******************************************************
short Cap;
int initRM;
int initRepl;
double lambdaProc;
double lambdaRepl;
double lambdaView;
double muAut;
double muMan;
int numFailed;
int numProc;
int numServices;
short repChos;
int replReq;

//********************************************************
//FinalExp1RangeStudy Constructor
//********************************************************
FinalExp1RangeStudy::FinalExp1RangeStudy() {

  // define arrays of global variable names and types
  NumGVs = 13;
  NumExps = 1;

  GVNames = new char*[NumGVs];
  GVTypes = new char*[NumGVs];
  GVNames[0]=strdup("Cap");
  GVTypes[0]=strdup("short");
  GVNames[1]=strdup("initRM");
  GVTypes[1]=strdup("int");
  GVNames[2]=strdup("initRepl");
  GVTypes[2]=strdup("int");
  GVNames[3]=strdup("lambdaProc");
  GVTypes[3]=strdup("double");
  GVNames[4]=strdup("lambdaRepl");
  GVTypes[4]=strdup("double");
  GVNames[5]=strdup("lambdaView");
  GVTypes[5]=strdup("double");
  GVNames[6]=strdup("muAut");
  GVTypes[6]=strdup("double");
  GVNames[7]=strdup("muMan");
  GVTypes[7]=strdup("double");
  GVNames[8]=strdup("numFailed");
  GVTypes[8]=strdup("int");
  GVNames[9]=strdup("numProc");
  GVTypes[9]=strdup("int");
  GVNames[10]=strdup("numServices");
  GVTypes[10]=strdup("int");
  GVNames[11]=strdup("repChos");
  GVTypes[11]=strdup("short");
  GVNames[12]=strdup("replReq");
  GVTypes[12]=strdup("int");

  // create the arrays to store the values of each gv
  CapValues = new short[NumExps];
  initRMValues = new int[NumExps];
  initReplValues = new int[NumExps];
  lambdaProcValues = new double[NumExps];
  lambdaReplValues = new double[NumExps];
  lambdaViewValues = new double[NumExps];
  muAutValues = new double[NumExps];
  muManValues = new double[NumExps];
  numFailedValues = new int[NumExps];
  numProcValues = new int[NumExps];
  numServicesValues = new int[NumExps];
  repChosValues = new short[NumExps];
  replReqValues = new int[NumExps];

  // call methods to assign values to each gv
  SetValues_Cap();
  SetValues_initRM();
  SetValues_initRepl();
  SetValues_lambdaProc();
  SetValues_lambdaRepl();
  SetValues_lambdaView();
  SetValues_muAut();
  SetValues_muMan();
  SetValues_numFailed();
  SetValues_numProc();
  SetValues_numServices();
  SetValues_repChos();
  SetValues_replReq();
  SetDefaultMobiusRoot(MOBIUSROOT);
}


//******************************************************
//FinalExp1RangeStudy Destructor
//******************************************************
FinalExp1RangeStudy::~FinalExp1RangeStudy() {
  delete [] CapValues;
  delete [] initRMValues;
  delete [] initReplValues;
  delete [] lambdaProcValues;
  delete [] lambdaReplValues;
  delete [] lambdaViewValues;
  delete [] muAutValues;
  delete [] muManValues;
  delete [] numFailedValues;
  delete [] numProcValues;
  delete [] numServicesValues;
  delete [] repChosValues;
  delete [] replReqValues;
  delete ThePVModel;
}


//******************************************************
// set values for Cap
//******************************************************
void FinalExp1RangeStudy::SetValues_Cap() {
  CapValues[0] = 4;
}


//******************************************************
// set values for initRM
//******************************************************
void FinalExp1RangeStudy::SetValues_initRM() {
  initRMValues[0] = 3;
}


//******************************************************
// set values for initRepl
//******************************************************
void FinalExp1RangeStudy::SetValues_initRepl() {
  initReplValues[0] = 3;
}


//******************************************************
// set values for lambdaProc
//******************************************************
void FinalExp1RangeStudy::SetValues_lambdaProc() {
  lambdaProcValues[0] = 1.0E-4;
}


//******************************************************
// set values for lambdaRepl
//******************************************************
void FinalExp1RangeStudy::SetValues_lambdaRepl() {
  lambdaReplValues[0] = 2.0E-4;
}


//******************************************************
// set values for lambdaView
//******************************************************
void FinalExp1RangeStudy::SetValues_lambdaView() {
  lambdaViewValues[0] = 1.0;
}


//******************************************************
// set values for muAut
//******************************************************
void FinalExp1RangeStudy::SetValues_muAut() {
  muAutValues[0] = 12.0;
}


//******************************************************
// set values for muMan
//******************************************************
void FinalExp1RangeStudy::SetValues_muMan() {
  muManValues[0] = 0.5;
}


//******************************************************
// set values for numFailed
//******************************************************
void FinalExp1RangeStudy::SetValues_numFailed() {
  numFailedValues[0] = 0;
}


//******************************************************
// set values for numProc
//******************************************************
void FinalExp1RangeStudy::SetValues_numProc() {
  numProcValues[0] = 4;
}


//******************************************************
// set values for numServices
//******************************************************
void FinalExp1RangeStudy::SetValues_numServices() {
  numServicesValues[0] = 3;
}


//******************************************************
// set values for repChos
//******************************************************
void FinalExp1RangeStudy::SetValues_repChos() {
  repChosValues[0] = 0;
}


//******************************************************
// set values for replReq
//******************************************************
void FinalExp1RangeStudy::SetValues_replReq() {
  replReqValues[0] = 1;
}



//******************************************************
//print values of gv (for debugging)
//******************************************************
void FinalExp1RangeStudy::PrintGlobalValues(int expNum) {
  if (NumGVs == 0) {
    cout<<"There are no global variables."<<endl;
    return;
  }

  SetGVs(expNum);

  cout<<"The Global Variable values for experiment "<<
    GetExpName(expNum)<<" are:"<<endl;
  cout << "Cap\tshort\t" << Cap << endl;
  cout << "initRM\tint\t" << initRM << endl;
  cout << "initRepl\tint\t" << initRepl << endl;
  cout << "lambdaProc\tdouble\t" << lambdaProc << endl;
  cout << "lambdaRepl\tdouble\t" << lambdaRepl << endl;
  cout << "lambdaView\tdouble\t" << lambdaView << endl;
  cout << "muAut\tdouble\t" << muAut << endl;
  cout << "muMan\tdouble\t" << muMan << endl;
  cout << "numFailed\tint\t" << numFailed << endl;
  cout << "numProc\tint\t" << numProc << endl;
  cout << "numServices\tint\t" << numServices << endl;
  cout << "repChos\tshort\t" << repChos << endl;
  cout << "replReq\tint\t" << replReq << endl;
}


//******************************************************
//retrieve the value of a global variable
//******************************************************
void *FinalExp1RangeStudy::GetGVValue(char *TheGVName) {
  if (strcmp("Cap", TheGVName) == 0)
    return &Cap;
  else if (strcmp("initRM", TheGVName) == 0)
    return &initRM;
  else if (strcmp("initRepl", TheGVName) == 0)
    return &initRepl;
  else if (strcmp("lambdaProc", TheGVName) == 0)
    return &lambdaProc;
  else if (strcmp("lambdaRepl", TheGVName) == 0)
    return &lambdaRepl;
  else if (strcmp("lambdaView", TheGVName) == 0)
    return &lambdaView;
  else if (strcmp("muAut", TheGVName) == 0)
    return &muAut;
  else if (strcmp("muMan", TheGVName) == 0)
    return &muMan;
  else if (strcmp("numFailed", TheGVName) == 0)
    return &numFailed;
  else if (strcmp("numProc", TheGVName) == 0)
    return &numProc;
  else if (strcmp("numServices", TheGVName) == 0)
    return &numServices;
  else if (strcmp("repChos", TheGVName) == 0)
    return &repChos;
  else if (strcmp("replReq", TheGVName) == 0)
    return &replReq;
  else 
    cerr<<"!! FinalExp1RangeStudy::GetGVValue: Global Variable "<<TheGVName<<" does not exist."<<endl;
  return NULL;
}


//******************************************************
//override the value of a global variable
//******************************************************
void FinalExp1RangeStudy::OverrideGVValue(char *TheGVName,void *TheGVValue) {
  if (strcmp("Cap", TheGVName) == 0)
    Cap = *(short *)TheGVValue;
  else if (strcmp("initRM", TheGVName) == 0)
    initRM = *(int *)TheGVValue;
  else if (strcmp("initRepl", TheGVName) == 0)
    initRepl = *(int *)TheGVValue;
  else if (strcmp("lambdaProc", TheGVName) == 0)
    lambdaProc = *(double *)TheGVValue;
  else if (strcmp("lambdaRepl", TheGVName) == 0)
    lambdaRepl = *(double *)TheGVValue;
  else if (strcmp("lambdaView", TheGVName) == 0)
    lambdaView = *(double *)TheGVValue;
  else if (strcmp("muAut", TheGVName) == 0)
    muAut = *(double *)TheGVValue;
  else if (strcmp("muMan", TheGVName) == 0)
    muMan = *(double *)TheGVValue;
  else if (strcmp("numFailed", TheGVName) == 0)
    numFailed = *(int *)TheGVValue;
  else if (strcmp("numProc", TheGVName) == 0)
    numProc = *(int *)TheGVValue;
  else if (strcmp("numServices", TheGVName) == 0)
    numServices = *(int *)TheGVValue;
  else if (strcmp("repChos", TheGVName) == 0)
    repChos = *(short *)TheGVValue;
  else if (strcmp("replReq", TheGVName) == 0)
    replReq = *(int *)TheGVValue;
  else 
    cerr<<"!! FinalExp1RangeStudy::OverrideGVValue: Global Variable "<<TheGVName<<" does not exist."<<endl;
}


//******************************************************
//set the value of all global variables to the given exp
//******************************************************
void FinalExp1RangeStudy::SetGVs(int expNum) {
  Cap = CapValues[expNum];
  initRM = initRMValues[expNum];
  initRepl = initReplValues[expNum];
  lambdaProc = lambdaProcValues[expNum];
  lambdaRepl = lambdaReplValues[expNum];
  lambdaView = lambdaViewValues[expNum];
  muAut = muAutValues[expNum];
  muMan = muManValues[expNum];
  numFailed = numFailedValues[expNum];
  numProc = numProcValues[expNum];
  numServices = numServicesValues[expNum];
  repChos = repChosValues[expNum];
  replReq = replReqValues[expNum];
}


//******************************************************
//static class method called by solvers to create study 
//(and thus create all of the model)
//******************************************************
BaseStudyClass* GlobalStudyPtr = NULL;
BaseStudyClass * GenerateStudy() {
  if (GlobalStudyPtr == NULL)
    GlobalStudyPtr = new FinalExp1RangeStudy();
  return GlobalStudyPtr;
}

void DestructStudy() {
  delete GlobalStudyPtr;
  GlobalStudyPtr = NULL;
}
//******************************************************
//get and create the PVModel
//******************************************************
PVModel* FinalExp1RangeStudy::GetPVModel(bool expandTimeArrays) {
  if (ThePVModel!=NULL)
    delete ThePVModel;
  // create the PV model
  ThePVModel=new SystemAvailPVModel(expandTimeArrays);
  return ThePVModel;
}


